<template>
    <div class="module-popup" :class="{'open':open}">
        <div @click="closeOpen" class="overlay"></div>
        <div class="popup">
            <div class="title">Are You Sure?</div>
            <div class="form">
                <div class="message">
                    Type/ Copy in the
                    <strong>Name</strong> of the Tag
                </div>
                <div class="message">
                    Name:
                    <strong>{{ existingName }}</strong>
                </div>
                <div class="form-control">
                    <input v-model="$v.name.$model" type="text" name="notebookName" />
                    <span class="error" v-if="!$v.name.sameAs && $v.name.$dirty">
                        <app-icon icon="exclamation-circle"></app-icon>
                        <span
                            class="message"
                        >Error: Typed Name Should Be The Same As Notebook To Be Deleted</span>
                    </span>
                    <span class="error" v-if="!$v.name.not && $v.name.$dirty">
                        <app-icon icon="exclamation-circle"></app-icon>
                        <span class="message">Error: Cannot Delete default Tag</span>
                    </span>
                </div>
            </div>
            <div class="warning">
                This action
                <strong>cannot</strong> be reversed.
            </div>
            <div class="actions">
                <button @click="confirmAction" class="delete">Delete The Tag</button>
                <button @click="closeOpen" class="cancel">Cancel</button>
            </div>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component, { mixins } from 'vue-class-component'
import { Prop, Watch } from 'vue-property-decorator'
import { ModulePopupMixin } from '@/app/Editor/components/mixins/ModulePopup'
import { ITag } from '@/store/types/tags'

@Component
export default class DeleteNotebookPopup extends mixins(ModulePopupMixin) {
    // Lifecycles

    created() {
        if (this.tag) this.existingName = this.tag.name
    }

    // Props

    @Prop() tag!: ITag

    // Watchers

    @Watch('tag')
    watchTag(newTag: ITag, oldTag: ITag) {
        this.existingName = newTag.name
    }

    // Methods

    invalid(): boolean {
        if (this.$v.name && this.$v.name.not) return false
        if (this.$v.name && this.$v.name.sameAs) return false
        return true
    }
}
</script>